import boto3
import errno
import os

UPLOAD_CHECK_INTERVAL = 10
UPLOAD_WAIT_TIMEOUT = 300

VALKYRIE_HOST = "https://verdict.valkyrie.comodo.com"
VALKYRIE_FILE_QUERY_API = VALKYRIE_HOST + "/api/v1/file/query/"
VALKYRIE_FILE_UPLOAD_API = VALKYRIE_HOST + "/api/v1/file/scan"


class VVReturnCodes:
    SUCCESS = 0
    FILE_NOT_EXISTS = 2
    REQUEST_LIMIT_REACHED = [100, 102]


VERDICT_CLEAN = "CLEAN"
VERDICT_MALWARE = "MALWARE"
VERDICT_PUA = "PUA"
VERDICT_UNDETECTED = "UNDETECTED"

VALKYRIE_VERDICT_MAP = {
    -1: "CLEAN",
    1: "MALWARE",
    3: "PUA",
    0: "UNDETECTED"
}

VV_SHA1_TAG = os.getenv("VV_SHA1_TAG", "vv-sha1")
VV_VERDICT_TAG = os.getenv("VV_VERDICT_TAG", "vv-verdict")
VV_STATUS_TAG = os.getenv("VV_STATUS_TAG", "vv-status")
VV_TIMESTAMP_TAG = os.getenv("VV_TIMESTAMP_TAG", "vv-timestamp")
VV_API_KEY = os.getenv("VV_API_KEY", "")
VV_BUCKET_NAME = os.getenv("VV_BUCKET_NAME", "")
VV_CRONJOB_INTERVAL = os.getenv("VV_CRONJOB_INTERVAL", 10)
VV_CHANGE_PERMISSION = (os.getenv("VV_CHANGE_PERMISSION", "false") == "true")
VV_ALLOWED_VERDICTS = (os.getenv("VV_ALLOWED_VERDICTS", "CLEAN,UNDETECTED"))

#TODO delete before deploy
# s3 = boto3.resource('s3', aws_access_key_id="AKIAJII7YIIULZXAQW5A", aws_secret_access_key="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", region_name="ca-central-1")
# s3_client = boto3.client('s3', aws_access_key_id="AKIAJII7YIIULZXAQW5A", aws_secret_access_key="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", region_name="ca-central-1")
s3 = boto3.resource('s3')
s3_client = boto3.client('s3')


def create_dir(path):
    if not os.path.exists(path):
        try:
            print("Attempting to create directiory %s.\n" % path)
            os.makedirs(path)
        except OSError as exc:
            if exc.errno != errno.EEXIST:
                raise
